public class SPIELFELD
{
    private int[] feld;
    private int freieFelder;

    public SPIELFELD()
    {
        feld = new int[9];
        for (int i=0; i<9; i++)
            feld[i] = 0;
        freieFelder = 9;
    }
    
    public SPIELFELD(SPIELFELD ausgangsfeld)
    {
        feld = new int[9];
        freieFelder = 9;
        for (int i=0; i<9; i++)
        {
            feld[i] = ausgangsfeld.feld[i];
            if (feld[i]!=0) freieFelder--;
        }
    }

    public void feldBelegen(int i, int wert)
    {
        if (i>=0 && i<=8)
        {
            if (wert!=0 && feld[i]==0)
                 freieFelder--;
            feld[i] = wert;
        }
    }
    
    public int gibFeld(int i)
    {
        return feld[i];
    }
    
    public int gibFreieFelder()
    {
        return freieFelder;
    }

    public int merken_maxzug()
    {
        int merker=0;
        SPIELFELD[] zukunftsfeld;
        zukunftsfeld = new SPIELFELD[freieFelder];
        int j=0;
        int maximum = -200;
        for (int i=0; i<freieFelder; i++)
        {
            while (feld[j]!=0) j++;
            zukunftsfeld[i] = new SPIELFELD(this);
            zukunftsfeld[i].feldBelegen(j,1);
            if (zukunftsfeld[i].minzug() > maximum)
            {
                maximum = zukunftsfeld[i].minzug();
                merker = j;
            }
            j++;
        }
        return merker;
    }   

    public int maxzug()
    {
        if (kreis_gewinnt()) return -99-freieFelder;
        if (kreuz_gewinnt()) return 99+freieFelder;
        if (freieFelder==0) return 0;
        SPIELFELD[] zukunftsfeld;
        zukunftsfeld = new SPIELFELD[freieFelder];
        int j=0;
        for (int i=0; i<freieFelder; i++)
        {
            while (feld[j]!=0) j++;
            zukunftsfeld[i] = new SPIELFELD(this);
            zukunftsfeld[i].feldBelegen(j,1);
            j++;
        }
        int maximum = -200;
        for (int i=0; i<freieFelder; i++)
        {
            if (zukunftsfeld[i].minzug() > maximum)
                maximum = zukunftsfeld[i].minzug();
        }
        return maximum;
    }   

    public int minzug()
    {
        if (kreis_gewinnt()) return -99-freieFelder;
        if (kreuz_gewinnt()) return 99+freieFelder;
        if (freieFelder==0) return 0;
        SPIELFELD[] zukunftsfeld;
        zukunftsfeld = new SPIELFELD[freieFelder];
        int j=0;
        for (int i=0; i<freieFelder; i++)
        {
            while (feld[j]!=0) j++;
            zukunftsfeld[i] = new SPIELFELD(this);
            zukunftsfeld[i].feldBelegen(j,-1);
            j++;
        }
        int minimum = 200;
        for (int i=0; i<freieFelder; i++)
        {
            if (zukunftsfeld[i].maxzug() < minimum)
                minimum = zukunftsfeld[i].maxzug();
        }
        return minimum;
    }   

    public void feldAusgeben()
    {
        for (int zeile=2; zeile>=0; zeile--) {
            for (int spalte=0; spalte<3; spalte++) {
                if(feld[zeile*3+spalte]==-1)
                    System.out.print(" O ");
                if(feld[zeile*3+spalte]==1)
                    System.out.print(" x ");
                if(feld[zeile*3+spalte]==0)
                    System.out.print("   ");
            }
            System.out.println();
        }
    }
    
    public boolean kreis_gewinnt()
    {
        boolean rückgabe = false;
        if (feld[0] == -1 && feld[1] == -1 && feld[2] == -1) rückgabe = true;
        if (feld[3] == -1 && feld[4] == -1 && feld[5] == -1) rückgabe = true;
        if (feld[6] == -1 && feld[7] == -1 && feld[8] == -1) rückgabe = true;
        if (feld[0] == -1 && feld[3] == -1 && feld[6] == -1) rückgabe = true;
        if (feld[1] == -1 && feld[4] == -1 && feld[7] == -1) rückgabe = true;
        if (feld[2] == -1 && feld[5] == -1 && feld[8] == -1) rückgabe = true;
        if (feld[0] == -1 && feld[4] == -1 && feld[8] == -1) rückgabe = true;
        if (feld[6] == -1 && feld[4] == -1 && feld[2] == -1) rückgabe = true;
        return rückgabe;
    }
    
    public boolean kreuz_gewinnt()
    {
        boolean rückgabe = false;
        if (feld[0] == 1 && feld[1] == 1 && feld[2] == 1) rückgabe = true;
        if (feld[3] == 1 && feld[4] == 1 && feld[5] == 1) rückgabe = true;
        if (feld[6] == 1 && feld[7] == 1 && feld[8] == 1) rückgabe = true;
        if (feld[0] == 1 && feld[3] == 1 && feld[6] == 1) rückgabe = true;
        if (feld[1] == 1 && feld[4] == 1 && feld[7] == 1) rückgabe = true;
        if (feld[2] == 1 && feld[5] == 1 && feld[8] == 1) rückgabe = true;
        if (feld[0] == 1 && feld[4] == 1 && feld[8] == 1) rückgabe = true;
        if (feld[6] == 1 && feld[4] == 1 && feld[2] == 1) rückgabe = true;
        return rückgabe;
    }
}